#include <stdio.h>
#include <stdlib.h>
#define square(x) ((x)*(x))

/*
*
*
*/
read_chunk(fp,w,k,fitt)
FILE *fp;
double *w;
int k;
double *fitt;
{  int i,j;
   int EndOfFile = 1;
   float fbuf;
   i=j=0;
   while((i<k)&&(EndOfFile))
   {  j=0;
      while((j<k)&&(EndOfFile))
      { if(j<(k-1))
	{ if(fscanf(fp,"%f ",&fbuf)==EOF) EndOfFile = 0;
	  else w[i*k+j] = fbuf; 
        }
	else 
	  {  if(fscanf(fp,"%f \n",&fbuf)==EOF) EndOfFile = 0;
	     else w[i*k+j] = fbuf; 
          }
	j++;
      }
      if(i==(k-1)) 
      { if(fscanf(fp,"%f \n",&fbuf)==EOF) EndOfFile = 0;
	else *fitt = fbuf;
      }
      i++;
   }
   return(EndOfFile);
}/* read_chunk() */

/*
*
*
*/
write_graph(fp,w,k,fitt)
FILE *fp;
double *w;
int k;
double fitt;
{  int i,j ;

   for(i=0;i<k-1;i++)
   {  for(j=0;j<k;j++) fprintf(fp,"%9.4f ",w[i*k+j]);
      fprintf(fp,"\n");
   }
   for(j=0;j<k;j++) fprintf(fp,"%9.4f ",w[i*k+j]);
   fprintf(fp,"%9.4f \n",fitt);
}

/*
*
*
*/
print_graph(w,k,fitt)
double *w;
int k;
double fitt;
{  int i,j ;
   printf("\n\n");
   for(i=0;i<k-1;i++)
   {  for(j=0;j<k;j++) printf("%9.4f ",w[i*k+j]);
      printf("\n");
   }
   for(j=0;j<k;j++) printf("%9.4f ",w[i*k+j]);
   printf("%9.4f \n",fitt);
}

/*
*
*
*/
assign_zero(cw,k)
double *cw;
int k;
{  int i,j;
   for(i=0;i<k;i++)
      for(j=0;j<k;j++)
        cw[i*k+j] = 0;
      
}/* end of assign_zero() */

/*
*
*
*/
div_all(cw,k,value)
double *cw;
int k;
double value;
{  int i,j;
   for(i=0;i<k;i++)
      for(j=0;j<k;j++)
        cw[i*k+j] /= value;
      
}/* end of assign_zero() */

/*
*
*
*/
add(cw,w,k)
double *cw, *w;
int k;
{  int i,j;
   for(i=0;i<k;i++)
      for(j=0;j<k;j++)
	 cw[i*k+j] += w[i*k+j];
}/* add() */

/*
*
*
*/
stat_pro(fpI,fpO,avg_fitt,size,arg)
FILE *fpI,*fpO;
double *avg_fitt;
int *size;
double **arg;
{  double *w;
   double *cw;
   double fittness;
   double cfitt=0.0;
   int k,i=0;
   FILE *FitValues;
   fscanf(fpI,"%d \n",&k);
   printf("Gr size is %d\n",k);
   if((FitValues=fopen("FitSorter.out","w"))!=NULL) {
   if((cw=(double *) calloc(k*k,sizeof(double)))!=NULL)
   {  assign_zero(cw,k); 
      if((w=(double *) calloc(k*k,sizeof(double)))!=NULL)
      {  while(read_chunk(fpI,w,k,&fittness))
         {  
            /*write_graph(fpO,w,k,fittness); */
	    add(cw,w,k);
	    cfitt += fittness;
            print_graph(w,k,fittness);
	    i++;
	    fprintf(FitValues," %d %f \n",i,fittness);
         }
         free(w);
      }
      div_all(cw,k,1.0*i);
      fittness = cfitt / (double)i;
      print_graph(cw,k,fittness);
      *avg_fitt = fittness;
      *arg = cw;
      /*free(cw); */
      *size = k;
   }    
     fclose(FitValues);/* Close the FitValues file */
   }
}/* stat_pro() */

/*
*
*
*/
double Variance_forMatrix(avg_weight,w,k)
double *avg_weight;
double *w;
int k;
{  int i,j;
   double V=0.0;

   /*printf("\n In Variance_forMatrix k = %d \n",k); */

   for(i=0;i<k;i++)
      for(j=0;j<k;j++)
        V += square((avg_weight[i*k+j]-w[i*k+j]));

   return(V);
}/* Variance_forMatrix() */

double print_Weights_Total(w,k)
double *w;
int k;
{
   int i,j ;
   double tot = 0.0;

   for(i=0;i<k;i++)
      for(j=0;j<k;j++)
       tot = tot + w[i*k+j];

/*   printf("\n TOTAL : %f ",tot);
*/

   return tot;

}/* end of print_Weights_Total() */

/*
*
*
*/
stat_pro2(fpI,fpO,avg_fitt,avg_weight)
FILE *fpI,*fpO;
double avg_fitt;
double *avg_weight;
{  double *w;
   double fittness, WVariance;
   int k,i=0;
   fscanf(fpI,"%d \n",&k);
   printf("Gr size is %d\n",k);

   if((w=(double *) calloc(k*k,sizeof(double)))!=NULL)
   {  printf("\nI got the memory\n"); 
      while(read_chunk(fpI,w,k,&fittness))
      {  
	/*fprintf(fpO,"\n New Weight matrix \n");
          write_graph(fpO,w,k,fittness);
          fprintf(fpO,"\n TOTAL = %f ", print_Weights_Total(w,k));
	*/

        WVariance = Variance_forMatrix(avg_weight,w,k);
        printf("\n %d  %12.5f %12.5f ",i,WVariance,square((avg_fitt-fittness)));
	fprintf(fpO,"\n%12.5f %12.5f %12.5f ",WVariance,square((avg_fitt-fittness)),fittness);
	i++;
      }
      free(w);
   }
   printf("\n");
}/* stat_pro() */

/*
*
*/
process(argc,argv)
int argc;
char *argv[];
{  FILE *fpIn, *fpOut;
   char OutFilename[34];
   double *avrWeight = NULL;
   char c;
   int size=0;
   double avrFittness = 0.0;
   sprintf(OutFilename,"StatRes.tex");

   if((fpIn=fopen(argv[1],"r"))!=NULL)
   {  if(argc>2) sprintf(OutFilename,"%30s",argv[2]);
      if((fpOut=fopen(OutFilename,"w"))!=NULL)
      {  stat_pro(fpIn,fpOut,&avrFittness,&size,&avrWeight);
	 printf("\n Average values are \n");
         print_graph(avrWeight,size,avrFittness);
         print_Weights_Total(avrWeight,size);
         fclose(fpIn);
	 c = (char) getchar();
         fpIn=fopen(argv[1],"r");
         
	 print_graph(avrWeight,size,avrFittness);

	 c = (char) getchar();
         stat_pro2(fpIn,fpOut,avrFittness,avrWeight);
	 fclose(fpOut);
      }
      else printf(" Output file %s could not open",OutFilename);
      fclose(fpIn);
   }
   else printf(" File %s does not exist",argv[1]);
}/* process */

/*
*
*
*/
main(argc,argv)
int argc;
char *argv[];
{  if(argc<2) printf("\n usage : <> InFileName [OutFileName] \n");
   else  process(argc,argv);
}
